package net.niuxiaoer.device_identity

import android.content.Context
import android.net.wifi.WifiManager
import android.util.Log
import java.io.*
import java.net.NetworkInterface
import java.util.*


fun getAddressMAC(context: Context): String {
    var mac = getWifiConnectionMacAddress(context)
    if (mac?.isNotEmpty() == true ) {
        return mac
    }

    mac = getAdressMacByInterface()
    if (mac?.isNotEmpty() == true )  {
        return mac
    }

    mac = getAddressMacByFile(context)
    if (mac?.isNotEmpty() == true )  {
        return mac
    }

    return ""
}
private fun getWifiConnectionMacAddress(context: Context): String? {
    try {
        val wifi = context.getSystemService(Context.WIFI_SERVICE) as WifiManager
        val info = wifi.connectionInfo
        return info.macAddress
    } catch (e: Exception) {
        Log.i("DRMID", "getWifiConnectionMacAddress, exception:$e")
    }
    return null
}


private fun getAddressMacByFile(context: Context): String? {
    val FILE_ADDRESS_MAC = "/sys/class/net/wlan0/address"
    return try {
        val wifiMan = context.getSystemService(Context.WIFI_SERVICE) as WifiManager
        val ret: String
        val wifiState = wifiMan.wifiState
        wifiMan.isWifiEnabled = true
        val fl = File(FILE_ADDRESS_MAC)
        val fin = FileInputStream(fl)
        ret = crunchifyGetStringFromStream(fin)
        fin.close()
        val enabled = WifiManager.WIFI_STATE_ENABLED == wifiState
        wifiMan.isWifiEnabled = enabled
        ret
    } catch (e: Exception) {
        ""
    }
}

private fun crunchifyGetStringFromStream(crunchifyStream: InputStream?): String {
    return if (crunchifyStream != null) {
        val crunchifyWriter: Writer = StringWriter()
        val crunchifyBuffer = CharArray(2048)
        try {
            val crunchifyReader: Reader = BufferedReader(InputStreamReader(crunchifyStream, "UTF-8"))
            var counter: Int
            while (crunchifyReader.read(crunchifyBuffer).also { counter = it } != -1) {
                crunchifyWriter.write(crunchifyBuffer, 0, counter)
            }
        } finally {
            crunchifyStream.close()
        }
        crunchifyWriter.toString()
    } else {
        "No Contents"
    }
}

private fun getAdressMacByInterface(): String? {
    try {
        val all: List<NetworkInterface> = Collections.list(NetworkInterface.getNetworkInterfaces())
        for (nif in all) {
            if (nif.name.equals("wlan0", ignoreCase = true)) {
                val macBytes = nif.hardwareAddress ?: return ""
                val res1 = StringBuilder()
                for (b in macBytes) {
                    res1.append(String.format("%02X:", b))
                }
                if (res1.length > 0) {
                    res1.deleteCharAt(res1.length - 1)
                }
                return res1.toString()
            }
        }
    } catch (e: Exception) {
        Log.e("DRMID", "Erreur lecture propriete Adresse MAC ")
    }
    return null
}